/*
The Safe STL enhancements are

Copyright (C) Horstmann Software Design Corp. 1995. All Rights Reserved.

You may freely use, copy, modify, or distribute these Safe STL enhancements
and this documentation for any purpose, provided (1) you charge NO FEE for
distributing these copyrighted materials and (2) you include both the
copyright notice and permission notice from Hewlett-Packard Company and this
copyright notice and permission notice. Horstmann Software Design Corporation
specifically disclaims that these materials might do anything useful at all.
If they work for you and don't destroy anything, you are in luck.
There is no free technical support available for these materials.

Please send bug reports/suggestions to horstman@cs.sjsu.edu.
For the most current version of these files, see
http://www.mathcs.sjsu.edu/faculty/horstman/safestl.html
*/

#include <vector.h>
#include <list.h>
#include <map.h>

#include <iostream.h>

using namespace std;

void vector_test()
{	vector<int> a;
	a.insert(a.begin(), 10, 23);

	cout << a[3] << endl;

	vector<int>::iterator p = a.begin();

	cout << *p << endl;

	a.reserve(1000);

	vector<int> b;
	b.insert(b.begin(), 10, 45);

	*p = 67;

	cout << *a.begin() << endl;
}

void list_test()
{  list<double> a;


	for (int i = 1; i <= 10; i++)
		a.push_front(i * i);

	for (list<double>::iterator it = a.begin(); it != a.end(); it++)
		cout << *it << " ";
	cout << endl;

	list<double>::iterator p = a.begin();
	a.erase(a.begin());

	cout << *p;


	list<double> b;
	for (list<double>::iterator it = b.begin(); it != a.end(); it++)
		cout << *it << " ";
	cout << endl;
}

int main()
{  typedef void (*Fun)();
	map<int, Fun, less<int> > menu;
	menu[1] = vector_test;
	menu[2] = list_test;

	cout << "Which test would you like to run?\n"
		<< "1 - Vector test\n"
		<< "2 - List test\n"
		<< "Please enter 1 or 2 (or another integer to see what happens): ";
	int choice;
	cin >> choice;

	((*menu.find(choice)).second)();

	return 0;
}


